Bug 1466844 - Review Request: modtools - Utilities for creating and managing modules
Review Request: modtools - Utilities for creating and managing modules
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Petr Hracek
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2017-06-30 10:10 EDT by dhodovsk
Modified: 2017-08-24 11:50 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2017-08-07 17:22:12 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
phracek: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description dhodovsk 2017-06-30 10:10:56 EDT
Spec URL: https://dhodovsk.fedorapeople.org/modtools.spec
SRPM URL: https://dhodovsk.fedorapeople.org/modtools-0.0.1-1.src.rpm
Description: Modtools now provides tools generating openshift templates
from module Dockerfiles and creating modulemd files
from package names (intended api of module).
Fedora Account System Username: dhodovsk
Comment 1 Petr Hracek 2017-07-11 06:07:39 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Dist tag is present.
- Package contains BR: python2-devel or python3-devel
- Package is not relocatable.
  Note: Package has a "Prefix:" tag
  See:
  http://fedoraproject.org/wiki/Packaging/Guidelines#RelocatablePackages


===== MUST items =====

Generic:
[!]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated". 32 files have unknown license. Detailed
     output of licensecheck in
     /home/phracek/work/1466844-modtools/licensecheck.txt
[!]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/lib/python2.7/site-packages/modularity,
     /usr/lib/python2.7/site-packages/contrib, /usr/lib/python2.7/site-
     packages/modtools-0.0.1-py2.7.egg-info
[!]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib/python2.7/site-
     packages/contrib, /usr/lib/python2.7/site-packages/modularity,
     /usr/lib/python2.7/site-packages/modtools-0.0.1-py2.7.egg-info,
     /usr/lib/python2.7/site-packages/tests
[x]: Package contains no bundled libraries without FPC exception.
[!]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[!]: Each %files section contains %defattr if rpm < 4.4
     Note: %defattr present but not needed
[x]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[ ]: Package uses nothing in %doc for runtime.
[ ]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[!]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[!]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[!]: Package meets the Packaging Guidelines::Python
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[!]: Buildroot is not present
     Note: Invalid buildroot found:
     %{_tmppath}/%{name}-%{version}-%{release}-buildroot
     See: http://fedoraproject.org/wiki/Packaging/Guidelines#BuildRoot_tag
[!]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
     Note: Found : Vendor: Dominika Hodovska <dhodovsk@redhat.com>
     See: http://fedoraproject.org/wiki/Packaging:Guidelines#Tags
[!]: Sources can be downloaded from URI in Source: tag
     Note: Could not download Source0:
     file:///home/dhodovsk/rpmbuild/SOURCES/modtools-0.0.1.tar.gz
     See: http://fedoraproject.org/wiki/Packaging:Guidelines#Tags
[!]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: %clean present but not required
[!]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[!]: Spec use %global instead of %define unless justified.
     Note: %define requiring justification: %define name modtools, %define
     version 0.0.1, %define unmangled_version 0.0.1, %define
     unmangled_version 0.0.1, %define release 1
[x]: Reviewer should test that the package builds in mock.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see
     attached diff).
     See: (this test has no URL)
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Checking: modtools-0.0.1-1.noarch.rpm
          modtools-0.0.1-1.src.rpm
modtools.noarch: W: spelling-error %description -l en_US openshift -> open shift, open-shift, downshift
modtools.noarch: W: spelling-error %description -l en_US modulemd -> module, modulo
modtools.noarch: W: spelling-error %description -l en_US api -> API, pi, ape
modtools.noarch: W: incoherent-version-in-changelog 0.0.1 ['0.0.1-1', '0.0.1-1']
modtools.noarch: W: no-documentation
modtools.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/contrib/modtools.py 644 /usr/bin/python3 
modtools.noarch: W: no-manual-page-for-binary modtools
modtools.src: W: spelling-error %description -l en_US openshift -> open shift, open-shift, downshift
modtools.src: W: spelling-error %description -l en_US modulemd -> module, modulo
modtools.src: W: spelling-error %description -l en_US api -> API, pi, ape
modtools.src:26: W: setup-not-quiet
2 packages and 0 specfiles checked; 1 errors, 10 warnings.




Rpmlint (installed packages)
----------------------------
modtools.noarch: W: spelling-error %description -l en_US openshift -> open shift, open-shift, downshift
modtools.noarch: W: spelling-error %description -l en_US modulemd -> module, modulo
modtools.noarch: W: spelling-error %description -l en_US api -> API, pi, ape
modtools.noarch: W: incoherent-version-in-changelog 0.0.1 ['0.0.1-1', '0.0.1-1']
modtools.noarch: W: no-documentation
modtools.noarch: E: non-executable-script /usr/lib/python2.7/site-packages/contrib/modtools.py 644 /usr/bin/python3 
modtools.noarch: W: no-manual-page-for-binary modtools
1 packages and 0 specfiles checked; 1 errors, 6 warnings.



Diff spec file in url and in SRPM
---------------------------------
--- /home/phracek/work/1466844-modtools/srpm/modtools.spec	2017-07-11 10:57:11.434232765 +0200
+++ /home/phracek/work/1466844-modtools/srpm-unpacked/modtools.spec	2017-06-30 16:06:58.000000000 +0200
@@ -9,5 +9,5 @@
 Version: %{version}
 Release: %{release}
-Source0: file:///home/dhodovsk/rpmbuild/SOURCES/%{name}-%{unmangled_version}.tar.gz
+Source0: http://releases.pagure.org/modularity/modularity-tools/%{name}-%{unmangled_version}.tar.gz
 License: MIT
 Group: Development/Libraries


Requires
--------
modtools (rpmlib, GLIBC filtered):
    /usr/bin/python
    python(abi)



Provides
--------
modtools:
    modtools
    python2.7dist(modtools)
    python2dist(modtools)



Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1466844
Buildroot used: fedora-25-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6


Commented by phracek:
- Please use GPLv2 or GPLv3 license. I would not use MIT.
- Fix changelog entry
- modtools.py has missing executable permissions. https://fedoraproject.org/wiki/Packaging/Guidelines#FilePermissions
- LICENSE is missing in UPSTREAM
- There is no owner for directory /usr/lib/python2.7/site-package/modularity
- There is missing man-page for mod-tools. I would prefer to create the one from help.
- tests are missing, although they are specified in upstream. I would prefer to execute it in %check section.
- Use proper Source URL https://fedoraproject.org/wiki/Packaging/SourceURL
- Package must own all directories that it creates. https://fedoraproject.org/wiki/Packaging/Guidelines#FileAndDirectoryOwnership
- do not use %define but %global https://fedoraproject.org/wiki/Packaging/Guidelines#macros
- Please read Packaging:Python guildelines, how to used in SPEC file https://fedoraproject.org/wiki/Packaging:Python
- Use python2_sitelib https://fedoraproject.org/wiki/Packaging:Python#Example_common_spec_file
- It is only Python2 package or Python3 or both?
Comment 3 Petr Hracek 2017-07-19 07:09:05 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Dist tag is present.


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated". 52 files have unknown license. Detailed
     output of licensecheck in
     /home/phracek/1466844-modtools/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[-]: Package uses nothing in %doc for runtime.
[-]: Package consistently uses macros (instead of hard-coded directory
     names).
[-]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[-]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: modtools-0.0.1-2.noarch.rpm
          modtools-0.0.1-2.src.rpm
modtools.noarch: W: spelling-error %description -l en_US openshift -> open shift, open-shift, downshift
modtools.noarch: W: spelling-error %description -l en_US modulemd -> module, modulo
modtools.noarch: W: spelling-error %description -l en_US api -> API, pi, ape
modtools.noarch: W: no-manual-page-for-binary modtools
modtools.src: W: spelling-error %description -l en_US openshift -> open shift, open-shift, downshift
modtools.src: W: spelling-error %description -l en_US modulemd -> module, modulo
modtools.src: W: spelling-error %description -l en_US api -> API, pi, ape
2 packages and 0 specfiles checked; 0 errors, 7 warnings.




Rpmlint (installed packages)
----------------------------
modtools.noarch: W: spelling-error %description -l en_US openshift -> open shift, open-shift, downshift
modtools.noarch: W: spelling-error %description -l en_US modulemd -> module, modulo
modtools.noarch: W: spelling-error %description -l en_US api -> API, pi, ape
modtools.noarch: W: no-manual-page-for-binary modtools
1 packages and 0 specfiles checked; 0 errors, 4 warnings.



Requires
--------
modtools (rpmlib, GLIBC filtered):
    /usr/bin/python3
    python(abi)
    python3-dockerfile-parse
    python3-modulemd
    python3-pdc-client



Provides
--------
modtools:
    modtools
    python3.5dist(modtools)
    python3dist(modtools)



Source checksums
----------------
http://releases.pagure.org/modularity/modularity-tools/modtools-0.0.1-2.tar.gz :
  CHECKSUM(SHA256) this package     : 72be708f23bef735fd69a88963e409b05879f7f4a4d9726d117d5b2cf4c68c79
  CHECKSUM(SHA256) upstream package : 72be708f23bef735fd69a88963e409b05879f7f4a4d9726d117d5b2cf4c68c79


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1466844
Buildroot used: fedora-25-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6


Please use in SPEC File https://fedoraproject.org/wiki/Packaging:DistTag#.25.7B.3Fdist.7D_in_the_Release:_field
Comment 4 Petr Hracek 2017-07-19 07:13:44 EDT
Ok, SPEC file is fine and package is REVIEWED. Well done.
Comment 5 Gwyn Ciesla 2017-07-19 18:53:11 EDT
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/modtools
Comment 6 Gwyn Ciesla 2017-07-19 18:57:09 EDT
Package request has been denied with the reason: Could not create package
Comment 7 dhodovsk 2017-07-21 06:49:47 EDT
Gwyn, could you please provide more info about the issue with the package creation?
Comment 8 Gwyn Ciesla 2017-07-26 08:24:56 EDT
Ugh, pkgdb error, sorry I missed it.  I've fixed it.
Comment 9 Petr Hracek 2017-07-27 09:42:13 EDT
Hi Gwyn,

I have a problem with installing modtools on rawhide.
https://koji.fedoraproject.org/koji/packageinfo?packageID=24402

Module is already built, but command:
$ sudo dnf install modtools --enablerepo=rawhide
Fedora - Rawhide - Developmental packages for the next Fedora release                                                                                                              5.2 MB/s |  56 MB     00:10    
Fedora 25 - x86_64 - Updates                                                                                                                                                       5.1 MB/s |  24 MB     00:04    
Fedora 25 - x86_64                                                                                                                                                                 5.4 MB/s |  50 MB     00:09    
Last metadata expiration check: 0:00:21 ago on Thu Jul 27 15:39:48 2017.
No package modtools available.
Error: Unable to find a match.
$

Building for other releases like F25:
$ gpush 
Total 0 (delta 0), reused 0 (delta 0)
remote: Emitting a message to the fedmsg bus.
remote: * Publishing information for 1 commits
To ssh://pkgs.fedoraproject.org/rpms/modtools
   f848b25..49d7bcc  f25 -> f25
$ fedpkg build 
/usr/lib/python2.7/site-packages/fedora/client/bodhi.py:48: DeprecationWarning: fedora.client.bodhi has been deprecated. Please use bodhi.client.bindings instead.
  DeprecationWarning)
Could not execute build: Package modtools-0.0.1-3 has already been built
Note: You can skip this check with --skip-nvr-check. See help for more info.
$
 



Also I am not able as a co-maintainer build modtools for other releases.
Comment 10 Gwyn Ciesla 2017-07-27 09:51:00 EDT
It looks like the build *just* finished.  It won't be installable via dnf until after the next rawhide compose. The build issue might be because your release tag lacks the dist tag.
Comment 11 Fedora Update System 2017-08-04 09:42:31 EDT
modtools-0.0.1-4.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-cbdf1db196
Comment 12 Fedora Update System 2017-08-07 02:23:16 EDT
modtools-0.0.1-4.fc26 has been pushed to the Fedora 26 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-cbdf1db196
Comment 13 Fedora Update System 2017-08-07 04:19:31 EDT
modtools-0.0.1-4.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-b35fa30e5d
Comment 14 Fedora Update System 2017-08-07 17:22:12 EDT
modtools-0.0.1-4.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.
Comment 15 Fedora Update System 2017-08-24 11:50:55 EDT
modtools-0.0.1-4.fc26 has been pushed to the Fedora 26 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.